// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from grbl_msgs:action/SendGcodeCmd.idl
// generated code does not contain a copyright notice

#ifndef GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__FUNCTIONS_H_
#define GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "grbl_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "grbl_msgs/action/detail/send_gcode_cmd__struct.h"

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_Goal
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_Goal__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Goal__init(grbl_msgs__action__SendGcodeCmd_Goal * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Goal__fini(grbl_msgs__action__SendGcodeCmd_Goal * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_Goal__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Goal *
grbl_msgs__action__SendGcodeCmd_Goal__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Goal__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Goal__destroy(grbl_msgs__action__SendGcodeCmd_Goal * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_Goal__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Goal__Sequence__init(grbl_msgs__action__SendGcodeCmd_Goal__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Goal__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Goal__Sequence__fini(grbl_msgs__action__SendGcodeCmd_Goal__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_Goal__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Goal__Sequence *
grbl_msgs__action__SendGcodeCmd_Goal__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Goal__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Goal__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_Goal__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_Result
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_Result__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Result__init(grbl_msgs__action__SendGcodeCmd_Result * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Result__fini(grbl_msgs__action__SendGcodeCmd_Result * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_Result__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Result *
grbl_msgs__action__SendGcodeCmd_Result__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Result__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Result__destroy(grbl_msgs__action__SendGcodeCmd_Result * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_Result__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Result__Sequence__init(grbl_msgs__action__SendGcodeCmd_Result__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Result__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Result__Sequence__fini(grbl_msgs__action__SendGcodeCmd_Result__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_Result__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Result__Sequence *
grbl_msgs__action__SendGcodeCmd_Result__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Result__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Result__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_Result__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_Feedback
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_Feedback__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Feedback__init(grbl_msgs__action__SendGcodeCmd_Feedback * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Feedback__fini(grbl_msgs__action__SendGcodeCmd_Feedback * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Feedback *
grbl_msgs__action__SendGcodeCmd_Feedback__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Feedback__destroy(grbl_msgs__action__SendGcodeCmd_Feedback * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__init(grbl_msgs__action__SendGcodeCmd_Feedback__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__fini(grbl_msgs__action__SendGcodeCmd_Feedback__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_Feedback__Sequence *
grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_Feedback__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_Feedback__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__init(grbl_msgs__action__SendGcodeCmd_SendGoal_Request * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__fini(grbl_msgs__action__SendGcodeCmd_SendGoal_Request * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_SendGoal_Request *
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__destroy(grbl_msgs__action__SendGcodeCmd_SendGoal_Request * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__init(grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__fini(grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence *
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_SendGoal_Request__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__init(grbl_msgs__action__SendGcodeCmd_SendGoal_Response * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__fini(grbl_msgs__action__SendGcodeCmd_SendGoal_Response * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_SendGoal_Response *
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__destroy(grbl_msgs__action__SendGcodeCmd_SendGoal_Response * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__init(grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__fini(grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence *
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_SendGoal_Response__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_GetResult_Request__init(grbl_msgs__action__SendGcodeCmd_GetResult_Request * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Request__fini(grbl_msgs__action__SendGcodeCmd_GetResult_Request * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_GetResult_Request *
grbl_msgs__action__SendGcodeCmd_GetResult_Request__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Request__destroy(grbl_msgs__action__SendGcodeCmd_GetResult_Request * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__init(grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__fini(grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence *
grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_GetResult_Request__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_GetResult_Response__init(grbl_msgs__action__SendGcodeCmd_GetResult_Response * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Response__fini(grbl_msgs__action__SendGcodeCmd_GetResult_Response * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_GetResult_Response *
grbl_msgs__action__SendGcodeCmd_GetResult_Response__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Response__destroy(grbl_msgs__action__SendGcodeCmd_GetResult_Response * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__init(grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__fini(grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence *
grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_GetResult_Response__Sequence * array);

/// Initialize action/SendGcodeCmd message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage
 * )) before or use
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__init(grbl_msgs__action__SendGcodeCmd_FeedbackMessage * msg);

/// Finalize action/SendGcodeCmd message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__fini(grbl_msgs__action__SendGcodeCmd_FeedbackMessage * msg);

/// Create action/SendGcodeCmd message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_FeedbackMessage *
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__create();

/// Destroy action/SendGcodeCmd message.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__destroy(grbl_msgs__action__SendGcodeCmd_FeedbackMessage * msg);


/// Initialize array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the number of elements and calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
bool
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__init(grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence * array, size_t size);

/// Finalize array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__fini(grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence * array);

/// Create array of action/SendGcodeCmd messages.
/**
 * It allocates the memory for the array and calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence *
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__create(size_t size);

/// Destroy array of action/SendGcodeCmd messages.
/**
 * It calls
 * grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_grbl_msgs
void
grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence__destroy(grbl_msgs__action__SendGcodeCmd_FeedbackMessage__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // GRBL_MSGS__ACTION__DETAIL__SEND_GCODE_CMD__FUNCTIONS_H_
