// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grbl_msgs:action/SendGcodeFile.idl
// generated code does not contain a copyright notice
#include "grbl_msgs/action/detail/send_gcode_file__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `file_path`
#include "rosidl_runtime_c/string_functions.h"

bool
grbl_msgs__action__SendGcodeFile_Goal__init(grbl_msgs__action__SendGcodeFile_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // file_path
  if (!rosidl_runtime_c__String__init(&msg->file_path)) {
    grbl_msgs__action__SendGcodeFile_Goal__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Goal__fini(grbl_msgs__action__SendGcodeFile_Goal * msg)
{
  if (!msg) {
    return;
  }
  // file_path
  rosidl_runtime_c__String__fini(&msg->file_path);
}

grbl_msgs__action__SendGcodeFile_Goal *
grbl_msgs__action__SendGcodeFile_Goal__create()
{
  grbl_msgs__action__SendGcodeFile_Goal * msg = (grbl_msgs__action__SendGcodeFile_Goal *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Goal));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_Goal));
  bool success = grbl_msgs__action__SendGcodeFile_Goal__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_Goal__destroy(grbl_msgs__action__SendGcodeFile_Goal * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_Goal__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_Goal__Sequence__init(grbl_msgs__action__SendGcodeFile_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_Goal * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_Goal *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_Goal));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_Goal__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Goal__Sequence__fini(grbl_msgs__action__SendGcodeFile_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_Goal__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_Goal__Sequence *
grbl_msgs__action__SendGcodeFile_Goal__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_Goal__Sequence * array = (grbl_msgs__action__SendGcodeFile_Goal__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Goal__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_Goal__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_Goal__Sequence__destroy(grbl_msgs__action__SendGcodeFile_Goal__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_Goal__Sequence__fini(array);
  }
  free(array);
}


bool
grbl_msgs__action__SendGcodeFile_Result__init(grbl_msgs__action__SendGcodeFile_Result * msg)
{
  if (!msg) {
    return false;
  }
  // success
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Result__fini(grbl_msgs__action__SendGcodeFile_Result * msg)
{
  if (!msg) {
    return;
  }
  // success
}

grbl_msgs__action__SendGcodeFile_Result *
grbl_msgs__action__SendGcodeFile_Result__create()
{
  grbl_msgs__action__SendGcodeFile_Result * msg = (grbl_msgs__action__SendGcodeFile_Result *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Result));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_Result));
  bool success = grbl_msgs__action__SendGcodeFile_Result__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_Result__destroy(grbl_msgs__action__SendGcodeFile_Result * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_Result__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_Result__Sequence__init(grbl_msgs__action__SendGcodeFile_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_Result * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_Result *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_Result));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_Result__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Result__Sequence__fini(grbl_msgs__action__SendGcodeFile_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_Result__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_Result__Sequence *
grbl_msgs__action__SendGcodeFile_Result__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_Result__Sequence * array = (grbl_msgs__action__SendGcodeFile_Result__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Result__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_Result__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_Result__Sequence__destroy(grbl_msgs__action__SendGcodeFile_Result__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_Result__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `status`
// already included above
// #include "rosidl_runtime_c/string_functions.h"

bool
grbl_msgs__action__SendGcodeFile_Feedback__init(grbl_msgs__action__SendGcodeFile_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // status
  if (!rosidl_runtime_c__String__init(&msg->status)) {
    grbl_msgs__action__SendGcodeFile_Feedback__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Feedback__fini(grbl_msgs__action__SendGcodeFile_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // status
  rosidl_runtime_c__String__fini(&msg->status);
}

grbl_msgs__action__SendGcodeFile_Feedback *
grbl_msgs__action__SendGcodeFile_Feedback__create()
{
  grbl_msgs__action__SendGcodeFile_Feedback * msg = (grbl_msgs__action__SendGcodeFile_Feedback *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Feedback));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_Feedback));
  bool success = grbl_msgs__action__SendGcodeFile_Feedback__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_Feedback__destroy(grbl_msgs__action__SendGcodeFile_Feedback * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_Feedback__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_Feedback__Sequence__init(grbl_msgs__action__SendGcodeFile_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_Feedback * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_Feedback *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_Feedback));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_Feedback__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_Feedback__Sequence__fini(grbl_msgs__action__SendGcodeFile_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_Feedback__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_Feedback__Sequence *
grbl_msgs__action__SendGcodeFile_Feedback__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_Feedback__Sequence * array = (grbl_msgs__action__SendGcodeFile_Feedback__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_Feedback__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_Feedback__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_Feedback__Sequence__destroy(grbl_msgs__action__SendGcodeFile_Feedback__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_Feedback__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `goal`
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__functions.h"

bool
grbl_msgs__action__SendGcodeFile_SendGoal_Request__init(grbl_msgs__action__SendGcodeFile_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!grbl_msgs__action__SendGcodeFile_Goal__init(&msg->goal)) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(grbl_msgs__action__SendGcodeFile_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  grbl_msgs__action__SendGcodeFile_Goal__fini(&msg->goal);
}

grbl_msgs__action__SendGcodeFile_SendGoal_Request *
grbl_msgs__action__SendGcodeFile_SendGoal_Request__create()
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Request * msg = (grbl_msgs__action__SendGcodeFile_SendGoal_Request *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Request));
  bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Request__destroy(grbl_msgs__action__SendGcodeFile_SendGoal_Request * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__init(grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_SendGoal_Request * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_SendGoal_Request *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__fini(grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_SendGoal_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence *
grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence * array = (grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__destroy(grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"

bool
grbl_msgs__action__SendGcodeFile_SendGoal_Response__init(grbl_msgs__action__SendGcodeFile_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Response__fini(grbl_msgs__action__SendGcodeFile_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

grbl_msgs__action__SendGcodeFile_SendGoal_Response *
grbl_msgs__action__SendGcodeFile_SendGoal_Response__create()
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Response * msg = (grbl_msgs__action__SendGcodeFile_SendGoal_Response *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Response));
  bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Response__destroy(grbl_msgs__action__SendGcodeFile_SendGoal_Response * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Response__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__init(grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_SendGoal_Response * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_SendGoal_Response *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_SendGoal_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__fini(grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_SendGoal_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence *
grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence * array = (grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__destroy(grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_SendGoal_Response__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"

bool
grbl_msgs__action__SendGcodeFile_GetResult_Request__init(grbl_msgs__action__SendGcodeFile_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grbl_msgs__action__SendGcodeFile_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Request__fini(grbl_msgs__action__SendGcodeFile_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

grbl_msgs__action__SendGcodeFile_GetResult_Request *
grbl_msgs__action__SendGcodeFile_GetResult_Request__create()
{
  grbl_msgs__action__SendGcodeFile_GetResult_Request * msg = (grbl_msgs__action__SendGcodeFile_GetResult_Request *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Request));
  bool success = grbl_msgs__action__SendGcodeFile_GetResult_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Request__destroy(grbl_msgs__action__SendGcodeFile_GetResult_Request * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_GetResult_Request__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__init(grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_GetResult_Request * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_GetResult_Request *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_GetResult_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__fini(grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_GetResult_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence *
grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence * array = (grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__destroy(grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_GetResult_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `result`
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__functions.h"

bool
grbl_msgs__action__SendGcodeFile_GetResult_Response__init(grbl_msgs__action__SendGcodeFile_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!grbl_msgs__action__SendGcodeFile_Result__init(&msg->result)) {
    grbl_msgs__action__SendGcodeFile_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Response__fini(grbl_msgs__action__SendGcodeFile_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  grbl_msgs__action__SendGcodeFile_Result__fini(&msg->result);
}

grbl_msgs__action__SendGcodeFile_GetResult_Response *
grbl_msgs__action__SendGcodeFile_GetResult_Response__create()
{
  grbl_msgs__action__SendGcodeFile_GetResult_Response * msg = (grbl_msgs__action__SendGcodeFile_GetResult_Response *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Response));
  bool success = grbl_msgs__action__SendGcodeFile_GetResult_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Response__destroy(grbl_msgs__action__SendGcodeFile_GetResult_Response * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_GetResult_Response__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__init(grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_GetResult_Response * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_GetResult_Response *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_GetResult_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__fini(grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_GetResult_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence *
grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence * array = (grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__destroy(grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_GetResult_Response__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__functions.h"
// Member `feedback`
// already included above
// #include "grbl_msgs/action/detail/send_gcode_file__functions.h"

bool
grbl_msgs__action__SendGcodeFile_FeedbackMessage__init(grbl_msgs__action__SendGcodeFile_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!grbl_msgs__action__SendGcodeFile_Feedback__init(&msg->feedback)) {
    grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(grbl_msgs__action__SendGcodeFile_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  grbl_msgs__action__SendGcodeFile_Feedback__fini(&msg->feedback);
}

grbl_msgs__action__SendGcodeFile_FeedbackMessage *
grbl_msgs__action__SendGcodeFile_FeedbackMessage__create()
{
  grbl_msgs__action__SendGcodeFile_FeedbackMessage * msg = (grbl_msgs__action__SendGcodeFile_FeedbackMessage *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_FeedbackMessage));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__action__SendGcodeFile_FeedbackMessage));
  bool success = grbl_msgs__action__SendGcodeFile_FeedbackMessage__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__action__SendGcodeFile_FeedbackMessage__destroy(grbl_msgs__action__SendGcodeFile_FeedbackMessage * msg)
{
  if (msg) {
    grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__init(grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__action__SendGcodeFile_FeedbackMessage * data = NULL;
  if (size) {
    data = (grbl_msgs__action__SendGcodeFile_FeedbackMessage *)calloc(size, sizeof(grbl_msgs__action__SendGcodeFile_FeedbackMessage));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__action__SendGcodeFile_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__fini(grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__action__SendGcodeFile_FeedbackMessage__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence *
grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__create(size_t size)
{
  grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence * array = (grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence *)malloc(sizeof(grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__destroy(grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence * array)
{
  if (array) {
    grbl_msgs__action__SendGcodeFile_FeedbackMessage__Sequence__fini(array);
  }
  free(array);
}
