// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from grbl_msgs:msg/State.idl
// generated code does not contain a copyright notice
#include "grbl_msgs/msg/detail/state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `state_name`
#include "rosidl_runtime_c/string_functions.h"

bool
grbl_msgs__msg__State__init(grbl_msgs__msg__State * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    grbl_msgs__msg__State__fini(msg);
    return false;
  }
  // state_name
  if (!rosidl_runtime_c__String__init(&msg->state_name)) {
    grbl_msgs__msg__State__fini(msg);
    return false;
  }
  // state
  return true;
}

void
grbl_msgs__msg__State__fini(grbl_msgs__msg__State * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // state_name
  rosidl_runtime_c__String__fini(&msg->state_name);
  // state
}

grbl_msgs__msg__State *
grbl_msgs__msg__State__create()
{
  grbl_msgs__msg__State * msg = (grbl_msgs__msg__State *)malloc(sizeof(grbl_msgs__msg__State));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(grbl_msgs__msg__State));
  bool success = grbl_msgs__msg__State__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
grbl_msgs__msg__State__destroy(grbl_msgs__msg__State * msg)
{
  if (msg) {
    grbl_msgs__msg__State__fini(msg);
  }
  free(msg);
}


bool
grbl_msgs__msg__State__Sequence__init(grbl_msgs__msg__State__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  grbl_msgs__msg__State * data = NULL;
  if (size) {
    data = (grbl_msgs__msg__State *)calloc(size, sizeof(grbl_msgs__msg__State));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = grbl_msgs__msg__State__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        grbl_msgs__msg__State__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
grbl_msgs__msg__State__Sequence__fini(grbl_msgs__msg__State__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      grbl_msgs__msg__State__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

grbl_msgs__msg__State__Sequence *
grbl_msgs__msg__State__Sequence__create(size_t size)
{
  grbl_msgs__msg__State__Sequence * array = (grbl_msgs__msg__State__Sequence *)malloc(sizeof(grbl_msgs__msg__State__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = grbl_msgs__msg__State__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
grbl_msgs__msg__State__Sequence__destroy(grbl_msgs__msg__State__Sequence * array)
{
  if (array) {
    grbl_msgs__msg__State__Sequence__fini(array);
  }
  free(array);
}
